﻿class Singleton {
    private Singleton() {
        Console.WriteLine("Singleton");
    }

    public void DoWork() {
        Console.WriteLine("DoWork");
    }

    public static Singleton Instance {
        get {
            return LazyInstance.Value;
        }
    }

    private static readonly Lazy<Singleton> LazyInstance = new Lazy<Singleton>( () => new Singleton() );
}


class Program {
    static public void Main() {
        System.Console.WriteLine("Main");
        Singleton.Instance.DoWork();
    }
}

